/*
 * This file is part of the e-field program written by Adam Cornett
 * This program is distrubuted under the General Public License.
 * The license is distrubed with the source in the file 'gpl.txt'
 */
package com.ajc.esim.core;

import com.ajc.esim.core.logging.ILogger;

/**
 * Background thread for repainting the screen. -No longer used-
 * 
 * @see sci.core.ReDrawThread
 * @deprecated
 */
@Deprecated
public class Background extends Thread {
	public static volatile boolean pauseReqested;

	public ILogger bLog = null;

	public volatile boolean paintOnce = false;

	public volatile int timeInt = 1500;

	public long totalT;

	private volatile boolean stopRequested;

	/**
	 * Creates a new Background object.
	 * 
	 * @param name
	 *            Name of thread
	 */
	public Background(String name) {
		this.setName(name);
		this.setPriority(4);
		this.setDaemon(true);
	}

	/**
	 * Starts the thread
	 */
	@Override
	public void run() {
		long lastPaint = Long.MIN_VALUE;
		long interval = 3000;

		while (!stopRequested) {
			if (pauseReqested) {
				try {
					Thread.sleep(2000);
				} catch (InterruptedException e) {
					Thread.currentThread().interrupt();
				}
			}

			while (!pauseReqested) {
				if ((System.currentTimeMillis() - lastPaint) > interval) {
					Launcher.win.reDraw();
					lastPaint = System.currentTimeMillis();
				}
			}
		}
	}

	/**
	 * Stops this thread
	 */
	public void stopGracefully() {
		stopRequested = true;
		Thread.currentThread().interrupt();
	}
}
