/*
 * This file is part of the e-field program written by Adam Cornett
 * This program is distrubuted under the General Public License.
 * The license is distrubed with the source in the file 'gpl.txt'
 */
package com.ajc.esim.core;

import java.util.ConcurrentModificationException;

/**
 * Thread for drawing the EFField window.
 */
public class ReDrawThread extends Thread {
	/**
	 * No args constructor creates new thread.
	 */
	public ReDrawThread() {
		this.setDaemon(true);
		this.setName("Redraw Field Thread");
	}

	/**
	 * Launches a new thread.
	 */
	@Override
	public void run() {
		try {
			if (Launcher.win.EFPanel.rdtDraw()) {
				Launcher.win.EFPanel.finishDraw();
			}
		} catch (InterruptedException e) {
			Launcher.win.setStatusLabel("Ready");
			return;
		}catch (ConcurrentModificationException e) {
			Launcher.win.setStatusLabel("Charge changed, please redraw.");
			return;
		}
		Launcher.win.EFPanel.repaint();
		Launcher.win.setStatusLabel("Ready");
	}
}
