/*
 * This file is part of the e-field program written by Adam Cornett
 * This program is distrubuted under the General Public License.
 * The license is distrubed with the source in the file 'gpl.txt'
 */
package com.ajc.esim.gui;

import java.awt.Font;

import javax.swing.JDialog;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import com.ajc.esim.core.Data;
import com.ajc.esim.core.Launcher;

public class About extends JDialog {

	public static String BuildInfo = null;

	public static String BuildNumber = Messages.getString("build.number");

	public static String BuildStatus = Messages.getString("About.BuildStatus");

	public static String CoreLines = Messages.getString("About.CoreLines");

	public static String GUILines = Messages.getString("About.GUILines");

	public static String info = null;

	public static String OtherLines = Messages.getString("About.OtherLines");

	public static int total = Integer.parseInt(CoreLines)
			+ Integer.parseInt(GUILines) + Integer.parseInt(OtherLines);

	public static void setupBuildInfo() {
		BuildInfo = "\nLines of Java Code:\nCore:" + CoreLines
				+ " \nGUI:" + GUILines + "\nOther:" + OtherLines
				+ "\nTotal:" + total;
	}

	public static void setupInfo() {
		info = "Created by Adam Cornett for AP Physics at Woodward Academy, 2005."
				+ "\nFor License see gpl.txt"
				+ "\nFor help see readme.htm"
				+ "\nIf you have questions, comments or a bug report, please visit http://sourceforge.net/projects/e-sim"
				+ "\nVersion:"
				+ Launcher.version
				+ "\nBuild Number:"
				+ BuildNumber
				+ "\nBuild Status:"
				+ BuildStatus
				+ "\nData Class Hash:" + Data.class.hashCode();
	}

	private JTextArea textArea = null;

	private JScrollPane textScrollPane = null; // @jve:decl-index=0:visual-constraint="572,349"

	/**
	 * Creates a new About object.
	 * 
	 * @param owner
	 */
	public About(java.awt.Frame owner) {
		super(owner);
		setupBuildInfo();
		setupInfo();
		initialize();
	}

	public void initialize() {
		this.setModal(true);
		this.setSize(510, 400);
		this.setTitle("About E-Field");
		this.setResizable(true);
		this.setLocationRelativeTo(Launcher.win);
		this.add(getTextScrollPane(), java.awt.BorderLayout.CENTER);
		this.addWindowListener(new java.awt.event.WindowAdapter() {

			@Override
			public void windowClosing(java.awt.event.WindowEvent e) {
				dispose();
			}
		});
		textArea.setText(info+BuildInfo);
	}

	private JTextArea getTextArea() {
		if (textArea == null) {
			textArea = new JTextArea();
			textArea.setEditable(false);
			textArea.setWrapStyleWord(true);
			textArea
					.setFont(new Font("Dialog", java.awt.Font.TRUETYPE_FONT, 16));
		}

		return textArea;
	}

	private JScrollPane getTextScrollPane() {
		if (textScrollPane == null) {
			textScrollPane = new JScrollPane();
			textScrollPane.setAutoscrolls(true);
			textScrollPane.setViewportView(getTextArea());
		}

		return textScrollPane;
	}
}
