/*
 * This file is part of the e-field program written by Adam Cornett
 * This program is distrubuted under the General Public License.
 * The license is distrubed with the source in the file 'gpl.txt'
 */
package com.ajc.esim.gui;

import java.awt.Panel;
import java.awt.event.ActionEvent;

import javax.swing.JButton;
import javax.swing.JOptionPane;

import com.ajc.esim.core.Charge;
import com.ajc.esim.core.Launcher;
import com.ajc.esim.core.PointCharge;

/**
 * Add Charge Dialog
 */
public class AddCharge extends EFDialog {
	private ChargePanel cp = new ChargePanel();

	private JButton cancelButton = null;

	private JButton okButton = null;

	private Panel panel1 = null;

	public AddCharge(java.awt.Frame owner) {
		super(owner);
		initialize();
	}

	public AddCharge(java.awt.Frame owner, int x, int y) {
		super(owner);
		initialize();
		cp.setXY(x, y);
	}

	@Override
	public void actionPerformed(ActionEvent arg0) {
		if (arg0.getActionCommand().equals("OK")) {
			okAction();
		} else if (arg0.getActionCommand().equals("CANCEL")) {
			cancelAction();
		}
	}

	public void initialize() {
		this.setTitle("Add Charge");
		this.setSize(331, 128);
		this.setModal(true);
		cp.setKeyListener(this);
		this.add(cp, java.awt.BorderLayout.NORTH);
		this.add(getPanel1(), java.awt.BorderLayout.SOUTH);
		this.setLocationRelativeTo(null);
		
	}

	@Override
	protected void cancelAction() {
		this.dispose();
	}

	@Override
	protected void okAction() {
		okButton.setEnabled(false);

		if (add()) {
			Launcher.win.updateAll();
			this.dispose();
		} else {
			okButton.setEnabled(true);
		}
	}

	private boolean add() {
		Charge temp;

		try {
			temp = new PointCharge(cp.getChargeVal(), cp.getXVal(), cp
					.getYVal());
		} catch (NumberFormatException e) {
			JOptionPane.showMessageDialog(this,
					"Error!\nPlease check fields and try again.");

			return false;
		}

		Launcher.dat.addCharge(temp);
		Launcher.dat.updateScales();

		return true;
	}

	private JButton getCancelButton() {
		if (cancelButton == null) {
			cancelButton = new JButton("Cancel");
			cancelButton.addActionListener(this);
			cancelButton.setActionCommand("CANCEL");
			cancelButton.setForeground(java.awt.Color.black);
		}

		return cancelButton;
	}

	private JButton getOkButton() {
		if (okButton == null) {
			okButton = new JButton("OK");
			okButton.addActionListener(this);
			okButton.setActionCommand("OK");
			okButton.setForeground(java.awt.Color.black);
			okButton.setEnabled(true);
		}

		return okButton;
	}

	private Panel getPanel1() {
		if (panel1 == null) {
			panel1 = new Panel();
			panel1.add(getOkButton(), null);
			panel1.add(getCancelButton(), null);
		}

		return panel1;
	}
} // @jve:decl-index=0:visual-constraint="21,21"
