/*
 * This file is part of the e-field program written by Adam Cornett
 * This program is distrubuted under the General Public License.
 * The license is distrubed with the source in the file 'gpl.txt'
 */
package com.ajc.esim.gui;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JDialog;
import javax.swing.JPanel;

import com.ajc.esim.core.Launcher;

/**
 * Created on Feb 5, 2005 Updated on Mar 9, 2005.
 */
public class ColorChooser extends JDialog implements ActionListener {
	public java.awt.Color cColor = new java.awt.Color(255, 255, 255);

	public JColorChooser jColorChooser = null;

	public int sel = 0;

	private JButton button = null;

	private JButton button1 = null;

	private JPanel panel = null;

	/**
	 * Creates a new ColorChooser object.
	 * 
	 * @param owner
	 *            DOCUMENT ME!
	 */
	public ColorChooser(Frame owner) {
		super(owner);
		initialize();
		this.setLocationRelativeTo(owner);
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param arg0
	 *            DOCUMENT ME!
	 */
	public void actionPerformed(ActionEvent arg0) {
		String action = arg0.getActionCommand();

		if (arg0.getActionCommand().equals("OK")) {
			if (sel == 1) {
				Launcher.dat.backgroundColor = jColorChooser.getColor();
				Launcher.dat.gridColor = Launcher.dat.negate(jColorChooser
						.getColor());
				Launcher.win.optwin.updateColors();
				Launcher.win.repaint();
			} else if (sel == 2) {
				Launcher.dat.posColor = jColorChooser.getColor();
				Launcher.win.optwin.updateColors();
				Launcher.win.repaint();
			} else if (sel == 3) {
				Launcher.dat.negColor = jColorChooser.getColor();
				Launcher.win.optwin.updateColors();
				Launcher.win.repaint();
			} else if (sel == 4) {
				Launcher.dat.text = jColorChooser.getColor();
				Launcher.win.optwin.updateColors();
				Launcher.win.repaint();
			} else if (sel == 5) {
				Launcher.dat.potentialColor = jColorChooser.getColor();
				Launcher.win.optwin.updateColors();
				Launcher.win.repaint();
			}

			this.dispose();
		}

		if (action.equals("CANCEL")) {
			this.dispose();
		}
	}

	/**
	 * DOCUMENT ME!
	 */
	public void initialize() {
		this.setModal(true);
		this.setTitle("Color"); // Generated
		this.setSize(440, 330);
		this.add(getPanel(), java.awt.BorderLayout.SOUTH); // Generated
		this.add(getJColorChooser(), java.awt.BorderLayout.CENTER); // Generated
	}

	private JButton getButton() {
		if (button == null) {
			button = new JButton("OK");
			button.addActionListener(this);
		}

		return button;
	}

	private JButton getButton1() {
		if (button1 == null) {
			button1 = new JButton("Cancel");
			button1.setActionCommand("CANCEL");
			button1.addActionListener(this);
		}

		return button1;
	}

	private JColorChooser getJColorChooser() {
		if (jColorChooser == null) {
			java.awt.Color temp = new java.awt.Color(0, 0, 0);

			if (sel == 1) {
				temp = Launcher.dat.backgroundColor;
			} else if (sel == 2) {
				temp = Launcher.dat.negColor;
			} else if (sel == 3) {
				temp = Launcher.dat.posColor;
			}

			jColorChooser = new JColorChooser(temp);
			jColorChooser.addMouseListener(new java.awt.event.MouseAdapter() {
				@Override
				public void mouseClicked(java.awt.event.MouseEvent e) {
					cColor = jColorChooser.getColor();
				}
			});
		}

		return jColorChooser;
	}

	private JPanel getPanel() {
		if (panel == null) {
			panel = new JPanel();
			panel.add(getButton(), null); // Generated
			panel.add(getButton1(), null); // Generated
		}

		return panel;
	}
} // @jve:decl-index=0:visual-constraint="10,10"
