/*
 * This file is part of the e-field program written by Adam Cornett
 * This program is distrubuted under the General Public License.
 * The license is distrubed with the source in the file 'gpl.txt'
 */
package com.ajc.esim.gui;

import java.awt.FileDialog;
import java.awt.Frame;

/**
 * Save/Load Dialog for Program Data
 */
public class LoadSettings extends FileDialog {
	public Frame own = null;

	/**
	 * Creates a new LoadSettings object.
	 * 
	 * @param owner
	 *            DOCUMENT ME!
	 */
	public LoadSettings(Frame owner) {
		super(owner);
		own = owner;
		initialize();
	}

	/**
	 * Creates a new LoadSettings object.
	 * 
	 * @param owner
	 *            DOCUMENT ME!
	 * @param title
	 *            DOCUMENT ME!
	 * @param mode
	 *            DOCUMENT ME!
	 */
	public LoadSettings(Frame owner, String title, int mode) {
		super(owner, title, mode);
		own = owner;
		initialize();
	}

	private void initialize() {
		this.setLocationRelativeTo(own);
		this.setDirectory(System.getProperty("user.dir"));
	}
}
