/*
 * Copyright (c) 2006 Adam Cornett 
 */
/*
 * Copyright (c) 2006 Adam Cornett
 */
package com.ajc.esim.gui;

import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JOptionPane;

import com.ajc.esim.core.Calc;
import com.ajc.esim.core.Launcher;

/**
 * @author Adam Cornett
 * 
 */
public class MainWinActionHandler implements ActionListener {

	/*
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */

	public void actionPerformed(ActionEvent arg0) {
		String actCmd = arg0.getActionCommand();
		Window win=null;
		if (actCmd.equals("EXIT")) {
			Launcher.Exit(0);
		} else if (actCmd.equals("CLEAR")) {
			Launcher.win.peClicks.clear();
			Launcher.dat.updateScales();
			Launcher.win.EFPanel.reDrawBackground = true;
			Launcher.win.reDraw();
		} else if (actCmd.equals("REDRAW")) {
			Launcher.win.reDraw();
			Launcher.win.EFPanel.reDrawBackground = true;
		} else if (actCmd.equals("ADD")) {
			win = new AddCharge(Launcher.win);
			win.setVisible(true);
			Launcher.win.updateList();
			Launcher.win.reDraw();
		} else if (actCmd.equals("REMOVE")) {
			Launcher.dat.removeCharge(Launcher.win.currentCharge);
			Launcher.win.nextCurrent();
			Launcher.dat.updateScales();
			Launcher.win.updateList();
			Launcher.win.reDraw();
		} else if (actCmd.equals("ABOUT")) {
			win = new About(Launcher.win);
			win.setVisible(true);
		} else if (actCmd.equals("EDIT")
				&& (Launcher.win.currentCharge != null)) {
			win = new EditCharge(Launcher.win);
			win.setVisible(true);
		} else if (actCmd.equals("DRAWHERE")) {
			Launcher.win.peClicks.add(new Double(Calc.totalPE(Launcher.win.x2,
					Launcher.win.y2)));
			Launcher.win.reDraw();
		} else if (actCmd.equals("DRAWHERE...")) {
			win = new DrawPHere(Launcher.win, Calc.totalPE(Launcher.win.x2,
					Launcher.win.y2));
			win.setVisible(true);
			Launcher.win.reDraw();
		} else if (actCmd.equals("ADDPOINTHERE")) {
			win = new AddCharge(Launcher.win, Launcher.win.x2, Launcher.win.y2);
			win.setVisible(true);
			Launcher.win.updateList();
			Launcher.win.reDraw();
		} else if (actCmd.equals("ADDLINEHERE")) {
			win = new AddCharge(Launcher.win, Launcher.win.x2, Launcher.win.y2);
			win.setVisible(true);
			Launcher.win.updateList();
			Launcher.win.reDraw();
		} else if (actCmd.equals("OPTIONS")) {
			Launcher.win.optwin = new OptionsFrame(Launcher.win);
			Launcher.win.optwin.setVisible(true);
		} else if (actCmd.equals("REMOVE ALL")) {
			if (JOptionPane.showConfirmDialog(Launcher.win,
					"Do you want to remove all charges?", "E-Field",
					JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
				Launcher.win.removeAll();
			}
			Launcher.win.reDraw();
		} else if (actCmd.equals("LOAD")) {
			win = new LoadSettings(Launcher.win, "Load", LoadSettings.LOAD);
			win.setVisible(true);
			if (((LoadSettings) win).getFile() != null) {
				Launcher.dat = Launcher.Load(((LoadSettings) win).getFile());
				Launcher.dat.rebuildAllShapes();
				Launcher.dat.updateScales();
				Launcher.win.updateAll();
				Launcher.win.reDraw();
			}
		} else if (actCmd.equals("SAVE")) {
			win = new LoadSettings(Launcher.win, "Save", LoadSettings.SAVE);
			win.setVisible(true);

			if (((LoadSettings) win).getFile() != null) {
				Launcher.Save(((LoadSettings) win).getFile());
			}
		} else if (actCmd.equals("PRINT")) {
			win = new com.ajc.esim.gui.printing.PrintDialog(Launcher.win);
			win.setVisible(true);
		} else if (actCmd.equals("PSETUP")) {
			System.out.println("not working yet");
		} else {
			JOptionPane.showMessageDialog(Launcher.win, actCmd,
					"Unknow Action", JOptionPane.ERROR_MESSAGE);
		}
	}

}
