/*
 * This file is part of the e-field program written by Adam Cornett
 * This program is distrubuted under the General Public License.
 * The license is distrubed with the source in the file 'gpl.txt'
 */
package com.ajc.esim.gui;

import javax.swing.JFrame;
import javax.swing.JLabel;

/**
 * Splash Screen for Program.
 */
public class Splash extends JFrame {

	private JLabel label = null;

	/**
	 * Creates a new Splash object.
	 */
	public Splash() {
		initialize();
	}

	private void initialize() {
		label = new JLabel();
		this.setUndecorated(true);
		this.setAlwaysOnTop(true);
		this.setSize(400, 250);
		this.setFont(new java.awt.Font("Dialog", java.awt.Font.ITALIC, 30));
		label.setFont(this.getFont());
		label.setText("   Loading E-Sim...   ");
		label.setHorizontalAlignment(JLabel.CENTER);
		this.add(label, java.awt.BorderLayout.CENTER);
		this.setLocationRelativeTo(null);
	}
}
