package com.ajc.esim.gui;

import javax.swing.InputVerifier;
import javax.swing.JComponent;
import javax.swing.text.JTextComponent;

public class WholeNumVerifier extends InputVerifier {
	/**
	 * For JTextComponents
	 * 
	 * @param arg0
	 *            JTextComponent to be verified
	 * 
	 * @return true if text passes verification, false otherwise
	 */
	@Override
	public boolean verify(JComponent arg0) {
		String text = ((JTextComponent) arg0).getText();

		if (text.equals("")) {
			return false;
		}

		int num = 0;

		try {
			num = Integer.parseInt(text);
		} catch (NumberFormatException e) {
			return false;
		}

		if (num <= 0) {
			return false;
		}

		return true;
	}
}
