package com.ajc.esim.gui.printing;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterException;
import java.io.IOException;
import java.io.InputStream;
import java.io.Reader;

import javax.print.Doc;
import javax.print.DocFlavor;
import javax.print.attribute.DocAttributeSet;
import javax.print.attribute.HashPrintRequestAttributeSet;
import javax.print.attribute.PrintRequestAttributeSet;
import javax.print.attribute.standard.MediaSizeName;

/**
 * Created on May 1, 2005 Updated on May 1, 2005
 */
public class EFDoc implements Printable {
	private Doc thisDoc = null;

	private DocFlavor myFormat = null;

	private PrintRequestAttributeSet aset = null;

	/**
	 * Creates a new EFDoc object.
	 * 
	 * @param mode
	 *            DOCUMENT ME!
	 */
	public EFDoc(int mode) {
		createAttrib();
	}

	/**
	 * DOCUMENT ME!
	 */
	public void createAttrib() {
		myFormat = DocFlavor.SERVICE_FORMATTED.PRINTABLE;
		aset = new HashPrintRequestAttributeSet();
		aset.add(MediaSizeName.NA_LETTER);
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public PrintRequestAttributeSet getAset() {
		return aset;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public Doc getDoc() {
		return thisDoc;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public DocFlavor getDocFlavor() {
		return myFormat;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param arg0
	 *            DOCUMENT ME!
	 * @param arg1
	 *            DOCUMENT ME!
	 * @param arg2
	 *            DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 * 
	 * @throws PrinterException
	 *             DOCUMENT ME!
	 */
	public int print(Graphics arg0, PageFormat arg1, int arg2)
			throws PrinterException {
		if (arg2 == 0) {
			arg1.setOrientation(PageFormat.LANDSCAPE);

			Graphics2D g2d = (Graphics2D) arg0;
			g2d.translate(arg1.getImageableX(), arg1.getImageableY());
			g2d.setColor(Color.black);
			g2d.drawString("Test String", 10, 10);

			return Printable.PAGE_EXISTS;
		}

		return Printable.NO_SUCH_PAGE;
	}

	class PrintableDoc implements Doc {
		private Printable printable;

		public PrintableDoc(Printable printable) {
			this.printable = printable;
		}

		public DocAttributeSet getAttributes() {
			return null;
		}

		public DocFlavor getDocFlavor() {
			return DocFlavor.SERVICE_FORMATTED.PRINTABLE;
		}

		public Object getPrintData() throws IOException {
			return printable;
		}

		public Reader getReaderForText() throws IOException {
			return null;
		}

		public InputStream getStreamForBytes() throws IOException {
			return null;
		}
	}
}
