package com.ajc.esim.gui.printing;

import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Choice;
import java.awt.Dialog;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.print.PrintService;

/**
 * Created on May 3, 2005 Updated on May 3, 2005
 */
public class PrintDialog extends Dialog implements ActionListener {
	private APrintJob apj = null;

	private Button CancelButton = null; // @jve:decl-index=0:visual-constraint="222,165"

	private Button printButton = null; // @jve:decl-index=0:visual-constraint="144,157"

	private Choice choice = null;

	private Label label = null;

	private Panel panel = null;

	private Panel panel1 = null;

	/**
	 * Creates a new PrintDialog object.
	 * 
	 * @param Owner
	 *            DOCUMENT ME!
	 */
	public PrintDialog(Frame Owner) {
		super(Owner);
		apj = new APrintJob();
		initialize();
		this.setTitle("Print");
		this.setLocationRelativeTo(Owner);
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param arg0
	 *            DOCUMENT ME!
	 */
	public void actionPerformed(ActionEvent arg0) {
		if (arg0.getActionCommand().equals("Cancel")) {
			this.dispose();
			this.setVisible(false);
		}

		if (arg0.getActionCommand().equals("Print")) {
			this.choice.setEnabled(false);
			this.CancelButton.setEnabled(false);
			this.printButton.setEnabled(false);

			if (apj.createPrintJob(choice.getSelectedIndex())) {
				apj.Print();
				this.dispose();
				this.setVisible(false);
			} else {
				System.out.println("error creating print job");
			}
		}
	}

	private Button getCancelButton() {
		if (CancelButton == null) {
			CancelButton = new Button();
			CancelButton.setLabel("Cancel"); // Generated }
			CancelButton.setName("CancelButton"); // Generated
			CancelButton.setActionCommand("Cancel");
			CancelButton.addActionListener(this);
		}

		return CancelButton;
	}

	private Choice getChoice() {
		if (choice == null) {
			choice = new Choice();

			PrintService[] list = this.apj.getPrinterList();

			for (int i = 0; i < list.length; i++) {
				if (list[i] != null) {
					choice.add(list[i].getName());
				}
			}
		}

		return choice;
	}

	private Panel getPanel() {
		if (panel == null) {
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			panel = new Panel();
			panel.setLayout(new GridBagLayout()); // Generated
			gridBagConstraints4.insets = new java.awt.Insets(4, 4, 4, 4); // Generated
			gridBagConstraints5.insets = new java.awt.Insets(4, 4, 4, 4); // Generated
			panel.add(getPrintButton(), gridBagConstraints4); // Generated
			panel.add(getCancelButton(), gridBagConstraints5); // Generated
		}

		return panel;
	}

	private Panel getPanel1() {
		if (panel1 == null) {
			label = new Label();

			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			panel1 = new Panel();
			panel1.setLayout(new GridBagLayout()); // Generated
			gridBagConstraints2.gridx = 1; // Generated
			gridBagConstraints2.gridy = 0; // Generated
			gridBagConstraints3.gridx = 0; // Generated
			gridBagConstraints3.gridy = 0; // Generated
			label.setText("Select Printer:"); // Generated
			panel1.add(getChoice(), gridBagConstraints2); // Generated
			panel1.add(label, gridBagConstraints3); // Generated
		}

		return panel1;
	}

	private Button getPrintButton() {
		if (printButton == null) {
			printButton = new Button();
			printButton.setLabel("Print"); // Generated
			printButton.setName("PrintButton"); // Generated
			printButton.addActionListener(this);
		}

		return printButton;
	}

	private void initialize() {
		this.setLayout(new BorderLayout()); // Generated
		this.setName("PrintDialog"); // Generated
		this.setModal(true); // Generated
		this.setTitle("Print"); // Generated
		this.setSize(362, 119); // Generated
		this.add(getPanel(), java.awt.BorderLayout.SOUTH); // Generated
		this.add(getPanel1(), java.awt.BorderLayout.CENTER); // Generated
	}
} // @jve:decl-index=0:visual-constraint="10,10"
